//==============================================================
// _CAO\
//--------------------------------------------------------------

#include "FreezeViewer.h"
#include <psputility.h>
#include <pspdisplay.h>
#include <pspgu.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "psp2ch.h"
#include "dialog.h"
#include "charConv.h"
#include "fvDraw.h"
#include "fileList.h"

extern S_2CH		s2ch;										// psp2ch.c
extern DirList		gFileList[4];								// fileList.c

//==============================================================
// ʍXV
//--------------------------------------------------------------

void minimalRender()
{
	guStart();
	sceGuScissor( 0, 0, SCR_WIDTH, SCR_HEIGHT );
	sceGuClearDepth(0);
	sceGuClear( GU_COLOR_BUFFER_BIT | GU_DEPTH_BUFFER_BIT );
	sceGuFinish();
	sceGuSync( 0, 0 );
}

//==============================================================
// PSPVXebZ[W_CAO̕\
//--------------------------------------------------------------
// fmt:\郁bZ[WiVtgJIS asciizj
//--------------------------------------------------------------
// PSP_CAOŃbZ[W\B
// tHg̓ǂݍ݂ĂȂĂbZ[W\łB
//--------------------------------------------------------------

void pspShowMessageDialog(char *fmt, ...)
{
	pspUtilityMsgDialogParams	dialog;
	SceSize						dialog_size = sizeof(dialog);
	int				done;
	va_list			list;
	char			msg[1024];

	va_start( list, fmt );
	vsprintf( msg, fmt, list );
	va_end( list );

	memset( &dialog, 0, dialog_size );
	dialog.base.size = dialog_size;
	dialog.base.language = PSP_SYSTEMPARAM_LANGUAGE_JAPANESE;
	sceUtilityGetSystemParamInt( PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &dialog.base.buttonSwap );
	dialog.base.graphicsThread = 0x11;
	dialog.base.accessThread   = 0x13;
	dialog.base.fontThread     = 0x12;
	dialog.base.soundThread    = 0x10;
	dialog.mode = PSP_UTILITY_MSGDIALOG_MODE_TEXT;
	psp2chSjis2UTF8( dialog.message, msg );
	dialog.options = PSP_UTILITY_MSGDIALOG_OPTION_TEXT;

	ScreenCopy2(0);												// wiޔ
	sceUtilityMsgDialogInitStart(&dialog);

	done = 0;
	while (!done && !gExitRequest) {
		minimalRender();
		ScreenPaste2();

		switch (sceUtilityMsgDialogGetStatus()) {
			case PSP_UTILITY_DIALOG_NONE:
				break;
			case PSP_UTILITY_DIALOG_INIT:
				break;
			case PSP_UTILITY_DIALOG_VISIBLE:
				sceUtilityMsgDialogUpdate(2);
				sceDisplayWaitVblankStart();
				break;
			case PSP_UTILITY_DIALOG_QUIT:
				sceUtilityMsgDialogShutdownStart();
				break;
			case PSP_UTILITY_DIALOG_FINISHED :
				done = 1;
				break;
		}
		sceDisplayWaitVblankStart();
		flipScreen(0);
	}
}

//==============================================================
// bZ[W_CAO̕\
//--------------------------------------------------------------
// msg    \郁bZ[WiVtgJISj
// type   0:eLXg
//        1:Yes/No
// ߂l 0:HOME{^ŏI
//        1:YES
//        2:NO
//        3:BACK
//--------------------------------------------------------------
// si\njŃbZ[W\B
// 蕶Ő܂ԂB
// PSP_CAŐUB
//--------------------------------------------------------------

static int ShowDialog(char *msg, int type)
{
	DrawImg			mask;
	DirList			*DList[4];
	unsigned char	*p;
	char	*dst, c[4], utf8[512], str[100], lineStr[6][100];
	int		i, y, ret, line, len, maxLen, count, blink, blFlg, pos;
	float	fy, alp;

	//----- bZ[W -----

	psp2chSjis2UTF8( utf8, msg );
	intraFontSetStyle( gJpn0, 0.7f, 0, 0, 0 );
	len = 0;
	maxLen = 0;
	line = 0;
	pos = 0;
	p = (unsigned char*) utf8;
	dst = str;
	while (*p) {
		if (*p <= 0x7F){										// 1oCgR[hiASCIIj
			c[0] = *(p++);
			c[1] = '\0';
		} else if (*p <= 0xDFU){								// 2oCgR[h
			c[0] = *(p++);
			c[1] = *(p++);
			c[2] = '\0';
		} else if (*p <= 0xEFU){								// 3oCgR[h
			c[0] = *(p++);
			c[1] = *(p++);
			c[2] = *(p++);
			c[3] = '\0';
		} else {
			p++;
			c[0] = '\0';
		}
		len += intraFontMeasureText( gJpn0, c );
		if (len > 400 || c[0]=='\n') {
			*dst = '\0';
			strcpy( lineStr[line], str );
			dst = str;
			if (maxLen < len) maxLen = len;
			len = 0;
			line++;
			if (line >= 6) break;
			if (c[0] == '\n') continue;
		}
		*(dst++) = c[0];
		if (c[1]) {
			*(dst++) = c[1];
			if (c[2]) {
				*(dst++) = c[2];
			}
		}
	}
	*dst = '\0';
	strcpy( lineStr[line], str );
	if (maxLen < len) maxLen = len;
	line++;

	//----- C[W -----

	mask.wx = 32;
	mask.wy = 272;
	mask.width = 512;
	mask.height = 272;
	mask.data = &VRAM[0][480];
	BoxFillImage( &mask, 0, 0, 32, 272, 0xFF808080 );			// ʊOE̖\}XNp̈ƂĎgp
	BoxFillImage( gEtcImg, 0, 0, 480, 32, 0 );
	BoxFillImage( gEtcImg, 0, 0, 320, 1, 0xFFFFFFFF );			// ㉺̐
	for (i=0; i<4; i++) {
		DList[i] = &gFileList[i];								// fBNgXg
	}
	ListDraw( DList, 0, 0 );
	ScreenCopy2(1);												// ʎ荞
	gScrBufFlg = 1;												// wiꎞobt@ω

	//----- _CAOC -----

	count = 0;
	blink = 100;
	blFlg = 0;
	pos = 1;
	fy = 0;
	ret = 0;
	while (!gExitRequest) {
		sceCtrlPeekBufferPositive( &s2ch.pad, 1 );
		if (s2ch.pad.Buttons != s2ch.oldPad.Buttons) {
			s2ch.oldPad = s2ch.pad;
			if (s2ch.pad.Buttons & PSP_CTRL_CROSS) {			// ~
				ret = 3;
				break;
			} else if (s2ch.pad.Buttons & PSP_CTRL_CIRCLE) {	// 
				ret = 1 + pos;
				break;
			} else if (s2ch.pad.Buttons & PSP_CTRL_RIGHT) {		// []
				if (type == 1) {
					pos = 1;
					blink = 100;
					blFlg = 0;
				}
			} else if (s2ch.pad.Buttons & PSP_CTRL_LEFT) {		// []
				if (type == 1) {
					pos = 0;
					blink = 100;
					blFlg = 0;
				}
			}
		}

		ScreenPaste2();											// ޔĂʂWJ
		guStart();
		sceGuClear(GU_DEPTH_BUFFER_BIT);

		if (count < 7) {										// _CAOJĂ
			alp = 0.25f + (count/6.0f) * 0.5f;
			for (i=0; i<480/32; i++) {
				DrawPicAlpha2( i*32, 40, &mask, 0, 0, 32, 232, alp, 1.0f );
			}
			sceGuClear(GU_DEPTH_BUFFER_BIT);
			count++;
			if (type == 0) {
				if (count != 7) {
					fy += ((line+1) * 20/2 - fy) / 3;
				} else {
					fy = (line+1) * 20/2;
				}
			} else {
				if (count != 7) {
					fy += ((line+3) * 20/2 - fy) / 3;
				} else {
					fy = (line+3) * 20/2;
				}
			}
			DrawPicAlpha( 240-(320/2), 272/2-fy, gEtcImg, alp, 1.0f );
			DrawPicAlpha( 240-(320/2), 272/2+fy, gEtcImg, alp, 1.0f );
			if (count == 7) {
				sceGuFinish();
				sceGuSync( 0, 0 );
				ScreenCopy2(1);									// ʎ荞
				guStart();
			}
			statusDraw1( DList[0], 0 );
			for (i=0; i<480/32; i++) {
				DrawPicAlpha2( i*32, 0, &mask, 0, 0, 32, 40, alp, 1.0f );
			}

		} else {												// _CAOJꂽ
			statusDraw1( DList[0], 0 );
			for (i=0; i<480/32; i++) {
				DrawPicAlpha2( i*32, 0, &mask, 0, 0, 32, 40, 0.75f, 1.0f );
			}
			y = 272 / 2 - fy + 26;
			for (i=0; i<line; i++) {
				if_print( 240-maxLen/2, y, lineStr[i], 0.7f, 0xFFFFFF, 0x202020, 1.0f );
				y += 20;
			}
			if (type == 0) {
				if_printSjis( 240-56, 272-8, "        ~߂", 0.7f, 0xFFFFFF, 0x202020, 1.0f );
			} else {
				if_printSjis( 240-56, 272-8, "~߂          ", 0.7f, 0xFFFFFF, 0x202020, 1.0f );
				y = 272 / 2 + (line+1) * 20 / 2 + 2;
				if_printSjis( 240-48, y, "͂        ", 0.8f, 0xFFFFFF, 0x202020, 1.0f );
				BoxFillImage( gCsrImg, 0, 0, 128, 16, 0 );
				if (pos == 0) {
					for (i=0; i<6; i++) {						// J[\C[W
						BoxFillImage( gCsrImg, i, i, 35-i*2, 16-i*2, 0xFFC0C0C0-(i<<29) );
					}
					DrawPicAlpha( 240-48-2, y-13, gCsrImg, blink/100.0f, 1.0f );
				} else {
					for (i=0; i<6; i++) {						// J[\C[W
						BoxFillImage( gCsrImg, i, i, 46-i*2, 16-i*2, 0xFFC0C0C0-(i<<29) );
					}
					DrawPicAlpha( 240-48+66, y-13, gCsrImg, blink/100.0f, 1.0f );
				}
			}
		}

		statusDraw2();											// ƃobe[c
		sceGuFinish();
		sceGuSync( 0, 0 );
		sceDisplayWaitVblankStart();
		flipScreen(0);

		if (blFlg) {											// J[\_
			blink += 3;
			if (blink >= 100) {
				blink = 100;
				blFlg = 0;
			}
		} else {
			blink -= 3;
			if (blink < 0) {
				blink = 0;
				blFlg = 1;
			}
		}
	}

	return ret;
}

//==============================================================
// bZ[W_CAŐNiYes/Noj
//--------------------------------------------------------------
// fmtF\郁bZ[WiVtgJIS asciizj
// ߂l 0:UNKNOWN1
//        1:YES
//        2:NO
//        3:BACK
//--------------------------------------------------------------

int MessageDialogYesNo(char *fmt, ...)
{
	va_list			list;
	char			msg[1024];

	va_start( list, fmt );
	vsprintf( msg, fmt, list );
	va_end( list );

	return ShowDialog( msg, 1 );
}

//==============================================================
// bZ[W_CAŐNi߂j
//--------------------------------------------------------------
// msgF\郁bZ[WiVtgJIS asciizj
// ߂l 3:BACK
//--------------------------------------------------------------

int MessageDialogText(char *fmt, ...)
{
	va_list			list;
	char			msg[1024];

	va_start( list, fmt );
	vsprintf( msg, fmt, list );
	va_end( list );

	return ShowDialog( msg, 0 );
}

//==============================================================
// OnScreenKeyboardŕ
//--------------------------------------------------------------
// titleFOSK̉Eɕ\^CgiVtgJISj
// text F͕ۑobt@iVtgJISj
// num  Ftext̃TCY
// linesF͕̍s
// ߂l 0:ωĂȂ
//        1:LZ
//        2:ωĂ
//--------------------------------------------------------------
// stextɓĂ镶񂪏͕ɂȂ܂B
// OSKLZꍇAtext̓e͕ω܂B
//--------------------------------------------------------------

int pspOSKDialog(char *title, char *text, int num, int lines)
{
	SceUtilityOskData	data;
	SceUtilityOskParams	dialog;
	DrawImg			mask;
	DirList			*DList[4];
	unsigned char	*p;
	unsigned short	string[256];
	unsigned short	pretext[256], text_buf[256];
	int				i, done, count;

	//----- R[hϊ -----

	if (num > 256) num = 256;
	if (title && *title != '\0') {
		p = (unsigned char*)title;
	} else {
		p = (unsigned char*)"";
	}
	psp2chSJIS2UCS( string, p, 255 );
	p = (unsigned char*)text;
	psp2chSJIS2UCS( pretext, p, 255 );

	//----- OSK_CAO -----

	memset( &data, 0, sizeof(data) );
	data.language = PSP_UTILITY_OSK_LANGUAGE_DEFAULT;
	data.unk_00 = 1;
	data.unk_04 = 0;
	data.language = PSP_UTILITY_OSK_LANGUAGE_DEFAULT;
	data.unk_12 = 0;
	data.inputtype = PSP_UTILITY_OSK_INPUTTYPE_ALL;
	data.lines = lines;
	data.unk_24 = 1;
	data.desc = string;
	data.intext = pretext;
	data.outtext = text_buf;
	data.outtextlength = num;
	data.outtextlimit = num;

	memset( &dialog, 0, sizeof(dialog) );
	dialog.base.size = sizeof(dialog);
	sceUtilityGetSystemParamInt( PSP_SYSTEMPARAM_ID_INT_LANGUAGE, &dialog.base.language );
	sceUtilityGetSystemParamInt( PSP_SYSTEMPARAM_ID_INT_UNKNOWN, &dialog.base.buttonSwap );
	dialog.base.graphicsThread = 0x11;
	dialog.base.accessThread   = 0x13;
	dialog.base.fontThread     = 0x12;
	dialog.base.soundThread    = 0x10;
	dialog.datacount = 1;
	dialog.data = &data;

	//----- C[W -----

	mask.wx = 32;
	mask.wy = 272;
	mask.width = 512;
	mask.height = 272;
	mask.data = &VRAM[0][480];
	BoxFillImage( &mask, 0, 0, 32, 272, 0xFF808080 );			// ʊOE̖\}XNp̈ƂĎgp

	sceGuSync( GU_SYNC_FINISH, GU_SYNC_WHAT_DONE );
	BoxFillImage( gEtcImg, 0, 0, 480, 32, 0 );
	BoxFillImage( gEtcImg, 0, 0, 320, 1, 0xFFFFFFFF );
	for (i=0; i<4; i++) {
		DList[i] = &gFileList[i];								// fBNgXg
	}
	ListDraw( DList, 0, 0 );
	sceKernelDelayThread(50000);								// 50ms~iBGMXbh쓮pj
	guStart();
	sceGuClear(GU_DEPTH_BUFFER_BIT);
	for (i=0; i<480/32; i++) {
		DrawPicAlpha2( i*32, 40, &mask, 0, 0, 32, 232, 0.75f, 1.0f );
	}
	sceGuFinish();
	sceGuSync( 0, 0 );
	ScreenCopy2(1);												// ʎ荞
	gScrBufFlg = 1;												// wiꎞobt@ω

	//----- OSKC -----

	sceUtilityOskInitStart(&dialog);

	done = 0;
	count = 0;
	while (!done && !gExitRequest) {
		if (count > 0) {										// OSKNV[PXŕׂ|ƃt[Y鎖炵
			ScreenPaste2();										// wi
			guStart();
			sceGuClear(GU_DEPTH_BUFFER_BIT);
			statusDraw1( DList[0], 0 );							// Xe[^Xĕ`
			for (i=0; i<480/32; i++) {
				DrawPicAlpha2( i*32, 0, &mask, 0, 0, 32, 40, 0.75f, 1.0f );
			}
			sceGuFinish();
		}

		switch (sceUtilityOskGetStatus()) {
		case PSP_UTILITY_DIALOG_NONE:
			done = 1;
			break;
		case PSP_UTILITY_DIALOG_VISIBLE:
			count++;											// NV[PXIĤȂ
			sceUtilityOskUpdate(1);
			break;
		case PSP_UTILITY_DIALOG_QUIT:
			sceUtilityOskShutdownStart();
			break;
		default:
			break;
		}

		guStart();
		statusDraw2();											// ƃobe[c
		sceGuFinish();
		sceDisplayWaitVblankStart();
		if (count > 1) {
			count = 1;
			flipScreen(0);
		}
	}

	//-----  -----

	if (data.result == 2) {										// 肵Ă
		psp2chUCS2SJIS((unsigned char*)text, text_buf, num);
	}
	return data.result;
}

